VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LSFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source !
'
' ACHTUNG! Diese Klasse ist von Benjamin Wilger (Benjamin@ActiveVB.de)
' verndert worden, sodass die LSRegistry-Klasse nicht mehr bentigt wird.
' Auerdem wurden einige Stellen ergnzt.
'
' Klasse LSFile
' ==================================================
' Erstellt von:
' Mirko Heinkel / LOGOsystems GmbH; Stand 15.11.2001
' mirko.heinkel@logo-systems.de
' http://www.logosystems.de
'
' die neuste version ist zu finden unter
' ======================================
' http://www.logosystems.de/visualbasic/lsfile.zip
'
'
' bereits enthaltene funktionen:
' ==============================
'    EINIGE FUNKTIONEN SIND NOCH NICHT AUSGIEBIG GETESTET WORDEN !!!!
'
'    TextLine_Add(FileName As String, TextLine As String) As Boolean
'    TextLine_Remove(FileName As String, Optional LastLine As Boolean, Optional LineNumber As Long) As Boolean
'    TextLine_Count(FileName As String) As Long
'    GetFileExtention(FileName As String) As String
'    GetName(FileName As String) As String
'    GetPath(FileName As String) As String
'    GetApplicationName(FileName As String) As String ' bei .doc == "Microsoft Word XY Dokument"
'    RenameFile(FileName As String, NewFileName As String) As Boolean
'    CopyFile(FileName As String, TargetName As String) As Boolean
'    RemoveFile(FileName As String) As Boolean
'    GetFileSize(FileName As String) As Long
'    GetFileCreationTime(FileName As String) As Date
'    GetLastChangeTime(FileName As String) As Date
'    GetLastAccessTime(FileName As String) As Date
'    SetLastAccessTime(FileName As String, NewTime As Date) As Boolean
'    SetLastChangeTime(FileName As String, NewTime As Date) As Boolean
'    SetFileCreationTime(FileName As String, NewTime As Date) As Boolean


Option Explicit

Const OF_READ = &H0
Const OF_WRITE = &H1
Const OFS_MAXPATHNAME = 128

Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function SetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function SystemTimeToFileTime Lib "kernel32" (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) As Long

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Enum RegKey
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_DYN_DATA = &H80000006
End Enum

Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_READ = KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const KEY_ALL_ACCESS = KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK
Private Const ERROR_SUCCESS = 0&
Private Const REG_SZ = 1
Private Const REG_DWORD = 4
Private Const REG_OPTION_NON_VOLATILE = &H0

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Any) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByValdwType As Long, lpData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueEx_Str Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long

Private Property Get GetValue(RegKey As RegKey, Key As String, Field As String, Value As Variant) As Boolean
    '
    ' Wert aus einem Feld der Registry auslesen
    '
    Dim Result As Long, hKey As Long, dwType As Long, Lng As Long, Buffer As String, l As Long
    
    Result = RegOpenKeyEx(RegKey, Key, 0, KEY_READ, hKey)
    
    If Result = ERROR_SUCCESS Then
        Result = RegQueryValueEx(hKey, Field, 0&, dwType, ByVal 0&, l)
        If Result = ERROR_SUCCESS Then
            Select Case dwType
                Case REG_SZ
                    Buffer = Space(l + 1)
                    Result = RegQueryValueEx(hKey, Field, 0&, dwType, ByVal Buffer, l)
                    If Result = ERROR_SUCCESS Then
                        Value = Buffer
                        If InStr(Value, Chr(0)) > 0 Then Value = Left(Value, InStr(Value, Chr(0)) - 1)  ' ungltige zeichen vorhanden
                    End If
                Case REG_DWORD
                    Result = RegQueryValueEx(hKey, Field, 0&, dwType, Lng, l)
                    If Result = ERROR_SUCCESS Then Value = Lng
            End Select
            If Result = ERROR_SUCCESS Then GetValue = True
        End If
    End If
    Result = RegCloseKey(hKey)
    
End Property

Private Property Get SetValue(RegKey As RegKey, Key As String, Field As String, Value As Variant) As Boolean
    '
    ' Wert in ein Feld der Registry schreiben
    '
    Dim Result As Long, hKey As Long, s As String, l As Long
    
    Result = RegOpenKeyEx(RegKey, Key, 0, KEY_ALL_ACCESS, hKey)
    
    If Result = ERROR_SUCCESS Then
        Select Case VarType(Value)
            Case vbInteger, vbLong
                l = CLng(Value)
                Result = RegSetValueEx(hKey, Field, 0, REG_DWORD, l, 4)
            Case vbString
                s = CStr(Value)
                Result = RegSetValueEx_Str(hKey, Field, 0, REG_SZ, s, Len(s) + 1)
        End Select
        If Result = ERROR_SUCCESS Then SetValue = True
        Result = RegCloseKey(hKey)
    End If
        
End Property

Private Property Get KeyExist(RegKey As RegKey, Key As String) As Boolean
    '
    ' Prfen ob ein Schlssel existiert
    '
    Dim Result As Long, hKey As Long
    
    Result = RegOpenKeyEx(RegKey, Key, 0, KEY_READ, hKey)
    If Result = ERROR_SUCCESS Then KeyExist = True
    Result = RegCloseKey(hKey)
    
End Property

Private Property Get CreateKey(RegKey As RegKey, Newkey As String) As Boolean
    '
    ' Neuen Schlssel erstellen
    '
    Dim Result As Long, hKey As Long, Back As Long
    
    Result = RegCreateKeyEx(RegKey, Newkey, 0, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, hKey, Back)
                          
    If Result = ERROR_SUCCESS Then
        Result = RegFlushKey(hKey)
        If Result = ERROR_SUCCESS Then CreateKey = True
        Result = RegCloseKey(hKey)
        CreateKey = Back
    End If
    
End Property

Private Property Get DeleteKey(RegKey As RegKey, Key As String) As Boolean
    '
    ' Schlssel erstellen
    '
    DeleteKey = IIf(RegDeleteKey(RegKey, Key) = ERROR_SUCCESS, True, False)
    
End Property

Private Property Get DeleteField(RegKey As RegKey, Key As String, Field As String) As Boolean
    '
    ' Feld lschen
    '
    Dim Result As Long, hKey As Long
    
    Result = RegOpenKeyEx(RegKey, Key, 0, KEY_ALL_ACCESS, hKey)
    
    If Result = ERROR_SUCCESS Then
        Result = RegDeleteValue(hKey, Field)
        If Result = ERROR_SUCCESS Then DeleteField = True
        Result = RegCloseKey(hKey)
    End If
    
End Property

Private Property Get EnumKeys(RegKey As RegKey, Key As String, ar() As String) As Boolean
    '
    ' keys in array zurckgeben
    '
    Dim Result As Long, hKey As Long, Cnt As Long, s As String
    
    Result = RegOpenKeyEx(RegKey, Key, 0, KEY_READ, hKey)
    
    If Result = ERROR_SUCCESS Then
        Do
            s = Space(256)
            Result = RegEnumKey(hKey, Cnt, s, 256)
            If Result = ERROR_SUCCESS Then
                ReDim Preserve ar(Cnt + 1)
                ar(Cnt + 1) = Trim(s)
            End If
            Cnt = Cnt + 1
        Loop While Result = ERROR_SUCCESS
    End If
    
    Result = RegCloseKey(hKey)
    On Error Resume Next
    
    If UBound(ar) = 0 Then
        EnumKeys = False
    Else
        EnumKeys = True
    End If
    
End Property

Public Property Get TextLine_Add(FileName As String, TextLine As String) As Boolean
    
    On Error GoTo err_TextLine_Add
    
    Dim fOut As Long
    
    fOut = FreeFile()
    
    Open FileName For Append As #fOut
    Print #fOut, TextLine
    Close fOut
    
    TextLine_Add = True
    
    Exit Property
err_TextLine_Add:
End Property

Public Property Get TextLine_Remove(FileName As String, Optional LastLine As Boolean = True, Optional LineNumber As Long) As Boolean
    
    On Error Resume Next
    
    Dim fNr As Long, fOut As Long
    Dim lngC As Long, s As String
    
    If LastLine = False And LineNumber = 0 Then Exit Property
    
    fNr = FreeFile()
    Open FileName For Input As fNr
    fOut = FreeFile()
    
    If Dir(FileName & "_lsfile.tempfile") <> "" Then Kill FileName & "_lsfile.tempfile"
    
    Open FileName & "_lsfile.tempfile" For Append As fOut
    
    If Err.Number > 0 Then
        Close fNr
        Close fOut
        Exit Property
    End If
    
    While Not EOF(fNr)
        lngC = lngC + 1
        Line Input #fNr, s
        If LastLine = True And EOF(fNr) Then
            TextLine_Remove = True
        ElseIf LastLine = True Then
            Print #fOut, s
        ElseIf LineNumber <> lngC Then
            Print #fOut, s
        Else
            TextLine_Remove = True
        End If
    Wend
    
    Close fNr
    Close fOut
    
    Kill FileName
    Name FileName & "_lsfile.tempfile" As FileName
    
End Property

Public Property Get TextLine_Count(FileName As String) As Long
    
    On Error GoTo err_TextLine_Count
    
    Dim fNr As Long
    Dim lngC As Long, s As String
    
    fNr = FreeFile()
    
    Open FileName For Input As fNr
    While Not EOF(fNr)
        Line Input #fNr, s
        lngC = lngC + 1
    Wend
        
    Close fNr
    
    TextLine_Count = lngC
    
    Exit Property
err_TextLine_Count:
    TextLine_Count = -1
End Property

Public Property Get GetFileExtention(FileName As String) As String
    
    On Error Resume Next
    
    Dim s As String
    
    If InStrRev(FileName, "\") > 0 Then
        s = Right(FileName, Len(FileName) - InStrRev(FileName, "\"))
    Else
        s = FileName
    End If
    
    If InStr(s, ".") > 0 Then
        s = Right(s, Len(s) - InStr(s, ".") + 1)
    End If
    
    GetFileExtention = s
    
End Property

Public Property Get GetName(FileName As String) As String
    
    On Error Resume Next

    If InStrRev(FileName, "\") > 0 Then
        GetName = Right(FileName, Len(FileName) - InStrRev(FileName, "\"))
    Else
        GetName = FileName
    End If
    
End Property

Public Property Get GetPath(FileName As String) As String
    
    On Error Resume Next

    If InStrRev(FileName, ".") > 0 And InStrRev(FileName, "\") > 0 Then
        If InStrRev(FileName, ".") >= InStrRev(FileName, "\") Then
            GetPath = Left(FileName, InStrRev(FileName, "\"))
        Else
            GetPath = FileName
        End If
    ElseIf InStrRev(FileName, "\") > 0 Then
        GetPath = FileName
    End If
    
End Property

Public Property Get GetApplicationName(FileName As String) As String
    
    On Error Resume Next
    
    Dim s, b As Boolean
    
    If InStrRev(FileName, ".") > 0 Then
        b = GetValue(HKEY_CLASSES_ROOT, Right(FileName, Len(FileName) - InStrRev(FileName, ".") + 1), "", s)
        b = GetValue(HKEY_CLASSES_ROOT, CStr(s), "", s)
        GetApplicationName = CStr(s)
    End If
    
End Property

Public Property Get RenameFile(FileName As String, NewFileName As String) As Boolean
    
    On Error Resume Next
    Name FileName As NewFileName
    If Err.Number = 0 Then RenameFile = True

End Property

Public Property Get CopyFile(FileName As String, TargetName As String) As Boolean
    
    On Error Resume Next
    FileCopy FileName, TargetName
    If Err.Number = 0 Then CopyFile = True

End Property

Public Property Get RemoveFile(FileName As String) As Boolean
    
    On Error Resume Next
    Kill FileName
    If Err.Number = 0 Then RemoveFile = True

End Property

Public Property Get GetFileSize(FileName As String) As Long
    
    Dim fNr As Long
    fNr = FreeFile()
    
    Open FileName For Input As fNr
    GetFileSize = LOF(fNr)
    Close fNr

End Property

Public Property Get GetFileCreationTime(FileName As String) As Date

    Dim hFile As Long, OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
    Dim sTime As SYSTEMTIME
     
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(FileName, OFS, OF_READ)
    
    If hFile > 0 Then
        Call GetFileTime(hFile, cTime, lTime, lwTime)
        Call FileTimeToSystemTime(cTime, sTime)
        GetFileCreationTime = Format$(CalcFTime(sTime), "dd.mm.yyyy hh:mm:ss") ' erstellt am
        Call CloseHandle(hFile)
    End If
    
End Property

Public Property Get GetLastChangeTime(FileName As String) As Date

    Dim hFile As Long, OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
    Dim sTime As SYSTEMTIME
     
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(FileName, OFS, OF_READ)
    
    If hFile > 0 Then
        Call GetFileTime(hFile, cTime, lTime, lwTime)
        Call FileTimeToSystemTime(lwTime, sTime)
        GetLastChangeTime = Format$(CalcFTime(sTime), "dd.mm.yyyy hh:mm:ss") ' letzte nderung
        Call CloseHandle(hFile)
    End If
    
End Property

Public Property Get GetLastAccessTime(FileName As String) As Date

    Dim hFile As Long, OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
    Dim sTime As SYSTEMTIME
     
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(FileName, OFS, OF_READ)
    
    If hFile > 0 Then
        Call GetFileTime(hFile, cTime, lTime, lwTime)
        Call FileTimeToSystemTime(lTime, sTime)
        GetLastAccessTime = Format$(CalcFTime(sTime), "dd.mm.yyyy hh:mm:ss") ' letzter zugriff
        Call CloseHandle(hFile)
    End If
    
End Property

Public Property Get SetLastAccessTime(FileName As String, NewTime As Date) As Boolean

    Dim hFile As Long, OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
'    Dim sTime As SYSTEMTIME
    
    Dim erTime As Date, geTime As Date, laTime As Date
    
    laTime = GetLastAccessTime(FileName)
    geTime = GetLastChangeTime(FileName)
    erTime = GetFileCreationTime(FileName)
    
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(FileName, OFS, OF_WRITE)
    If hFile > 0 Then
        cTime = CalcNewfTime(Format(erTime, "dd.mm.yyyy hh:mm:ss")) ' erstellt
        lTime = CalcNewfTime(Format(geTime, "dd.mm.yyyy hh:mm:ss")) ' gendert
        lwTime = CalcNewfTime(Format(NewTime, "dd.mm.yyyy hh:mm:ss")) ' letzter zugriff
        Call SetFileTime(hFile, cTime, lTime, lwTime)
        Call CloseHandle(hFile)
        SetLastAccessTime = True
    Else
        SetLastAccessTime = False
    End If
    
End Property

Public Property Get SetLastChangeTime(FileName As String, NewTime As Date) As Boolean

    Dim hFile As Long, OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
'    Dim sTime As SYSTEMTIME
    
    Dim erTime As Date, geTime As Date, laTime As Date
    
    laTime = GetLastAccessTime(FileName)
    geTime = GetLastChangeTime(FileName)
    erTime = GetFileCreationTime(FileName)
    
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(FileName, OFS, OF_WRITE)
    If hFile > 0 Then
        cTime = CalcNewfTime(Format(erTime, "dd.mm.yyyy hh:mm:ss")) ' erstellt
        lTime = CalcNewfTime(Format(NewTime, "dd.mm.yyyy hh:mm:ss")) ' gendert
        lwTime = CalcNewfTime(Format(laTime, "dd.mm.yyyy hh:mm:ss")) ' letzter zugriff
        Call SetFileTime(hFile, cTime, lTime, lwTime)
        Call CloseHandle(hFile)
        SetLastChangeTime = True
    Else
        SetLastChangeTime = False
    End If
    
End Property

Public Property Get SetFileCreationTime(FileName As String, NewTime As Date) As Boolean

    Dim hFile As Long, OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
'    Dim sTime As SYSTEMTIME
    
    Dim erTime As Date, geTime As Date, laTime As Date
    
    laTime = GetLastAccessTime(FileName)
    geTime = GetLastChangeTime(FileName)
    erTime = GetFileCreationTime(FileName)
    
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(FileName, OFS, OF_WRITE)
    If hFile > 0 Then
        cTime = CalcNewfTime(Format(NewTime, "dd.mm.yyyy hh:mm:ss")) ' erstellt
        lTime = CalcNewfTime(Format(geTime, "dd.mm.yyyy hh:mm:ss")) ' gendert
        lwTime = CalcNewfTime(Format(laTime, "dd.mm.yyyy hh:mm:ss")) ' letzter zugriff
        Call SetFileTime(hFile, cTime, lTime, lwTime)
        Call CloseHandle(hFile)
        SetFileCreationTime = True
    Else
        SetFileCreationTime = False
    End If
    
End Property

Private Function CalcFTime(FTime As SYSTEMTIME) As Date

    Dim Datum$, Zeit$, mm$, ss$, DT As Date
    Dim Da$, Mo$, Ye$
'    Dim aa$

    With FTime
        Da = .wDay
        If Len(Da) < 2 Then Da = "0" & Da
        
        Mo = .wMonth
        If Len(Mo) < 2 Then Mo = "0" & Mo
        
        Ye = CStr(.wYear)
        Datum = Da & "." & Mo & "." & Ye
        
        mm = Trim$(CStr(.wMinute))
        If Len(mm) < 2 Then mm = "0" & mm
        
        ss = Trim$(CStr(.wSecond))
        If Len(ss) < 2 Then ss = "0" & ss
        
        Zeit = .wHour + 1 & ":" & mm & ":" & ss
        If Zeit = "24:00:00" Then Zeit = "00:00:00"
        DT = CDate(Datum & " " & Zeit)
        CalcFTime = DT
    End With
    
End Function

Private Function CalcNewfTime(Datum$) As FILETIME
    
    Dim SysT As SYSTEMTIME, FT As FILETIME
     
    With SysT
        .wDay = CInt(Left$(Datum, 2))
        .wMonth = CInt(Mid$(Datum, 4, 2))
        .wYear = CInt(Mid$(Datum, 7, 4))
        .wHour = CInt(Mid$(Datum, 12, 2))
        .wMinute = CInt(Mid$(Datum, 15, 2))
        .wSecond = CInt(Mid$(Datum, 18, 2))
    End With
    
    Call SystemTimeToFileTime(SysT, FT)
    CalcNewfTime = FT
    
End Function
